CUDNN Frontend API 8.3.0

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
cudnn_frontend::BackendDescriptor Class Referenceabstract

`#include <cudnn_backend_base.h>`

Inheritance diagram for cudnn_frontend::BackendDescriptor:
Collaboration diagram for cudnn_frontend::BackendDescriptor:

## Public Member Functions
virtual std::string | describe () const =0
| Return a string describing the backend Descriptor. More...
cudnnBackendDescriptor_t | get_raw_desc () const
cudnnStatus_t | get_status () const
| Current status of the descriptor. More...
void | set_status (cudnnStatus_t const status_) const
| Set status of the descriptor. More...
void | set_error (const char *message) const
| Set Diagonistic error message. More...
const char * | get_error () const
| Diagonistic error message if any. More...
ManagedOpaqueDescriptor | get_desc () const
| Returns a copy of underlying managed descriptor. More...
cudnnStatus_t | initialize_managed_backend_pointer (cudnnBackendDescriptorType_t type)
| Initializes the underlying managed descriptor. More...

## Protected Member Functions
| BackendDescriptor (ManagedOpaqueDescriptor pointer_, cudnnStatus_t status_, std::string err_msg_)
| BackendDescriptor ()=default

## Protected Attributes
ManagedOpaqueDescriptor | pointer
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| Shared pointer of the OpaqueBackendPointer. More...
std::string | err_msg
| Error message if any being set. More...

## Detailed Description

BackendDescriptor class Holds a Managed pointer to OpaqueBackendPointer class Contains the status and error message if set after any operation. If exception is disabled the user must query the status after build operation in order to check if the cudnn construct was built correctly.

Definition at line 99 of file cudnn_backend_base.h.

## Constructor & Destructor Documentation

## ◆ BackendDescriptor() [1/2]

cudnn_frontend::BackendDescriptor::BackendDescriptor | ( | ManagedOpaqueDescriptor | pointer_,
|  | cudnnStatus_t | status_,
|  | std::string | err_msg_
| ) |  |
| inlineprotected

BackendDescriptor constructor. Initializes the member variables as passed.

Definition at line 154 of file cudnn_backend_base.h.

## ◆ BackendDescriptor() [2/2]

cudnn_frontend::BackendDescriptor::BackendDescriptor | ( |  | ) |
| protecteddefault

## Member Function Documentation

## ◆ describe()

virtual std::string cudnn_frontend::BackendDescriptor::describe | ( |  | ) | const
| pure virtual

Return a string describing the backend Descriptor.

Implemented in cudnn_frontend::Engine_v8, cudnn_frontend::EngineFallbackList_v8, cudnn_frontend::ExecutionPlan_v8, cudnn_frontend::Operation_v8, cudnn_frontend::PointWiseDesc_v8, cudnn_frontend::ConvDesc_v8, cudnn_frontend::EngineConfig_v8, cudnn_frontend::OperationGraph_v8, cudnn_frontend::Tensor_v8, cudnn_frontend::VariantPack_v8, cudnn_frontend::ReductionDesc_v8, cudnn_frontend::EngineHeuristics_v8, and cudnn_frontend::MatMulDesc_v8.

Referenced by cudnn_frontend::operator<<().

## ◆ get_desc()

ManagedOpaqueDescriptor cudnn_frontend::BackendDescriptor::get_desc | ( |  | ) | const
| inline

Returns a copy of underlying managed descriptor.

Definition at line 138 of file cudnn_backend_base.h.

## ◆ get_error()

const char* cudnn_frontend::BackendDescriptor::get_error | ( |  | ) | const
| inline

Diagonistic error message if any.

Definition at line 132 of file cudnn_backend_base.h.

## ◆ get_raw_desc()

cudnnBackendDescriptor_t cudnn_frontend::BackendDescriptor::get_raw_desc | ( |  | ) | const
| inline

Get a copy of the raw descriptor pointer. Ownership is reatined and gets deleted when out of scope

Definition at line 108 of file cudnn_backend_base.h.

## ◆ get_status()

cudnnStatus_t cudnn_frontend::BackendDescriptor::get_status | ( |  | ) | const
| inline

Current status of the descriptor.

Definition at line 114 of file cudnn_backend_base.h.

References cudnn_frontend::OpaqueBackendPointer::status.

## ◆ initialize_managed_backend_pointer()

cudnnStatus_t cudnn_frontend::BackendDescriptor::initialize_managed_backend_pointer | ( | cudnnBackendDescriptorType_t | type | ) |
| inline

Initializes the underlying managed descriptor.

Definition at line 144 of file cudnn_backend_base.h.

References cudnn_frontend::make_shared_backend_pointer().

Referenced by cudnn_frontend::OperationBuilder_v8::build().

## ◆ set_error()

void cudnn_frontend::BackendDescriptor::set_error | ( | const char * | message | ) | const
| inline

Set Diagonistic error message.

Definition at line 126 of file cudnn_backend_base.h.

Referenced by cudnn_frontend::set_error_and_throw_exception().

## ◆ set_status()

void cudnn_frontend::BackendDescriptor::set_status | ( | cudnnStatus_t const | status_ | ) | const
| inline

Set status of the descriptor.

Definition at line 120 of file cudnn_backend_base.h.

References cudnn_frontend::OpaqueBackendPointer::status.

Referenced by cudnn_frontend::set_error_and_throw_exception().

## Member Data Documentation

## ◆ err_msg

std::string cudnn_frontend::BackendDescriptor::err_msg
| mutableprotected

Error message if any being set.

Definition at line 161 of file cudnn_backend_base.h.

## ◆ pointer

ManagedOpaqueDescriptor cudnn_frontend::BackendDescriptor::pointer
| protected

Definition at line 158 of file cudnn_backend_base.h.

Referenced by cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_matmul_op(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::build_reduction_op(), cudnn_frontend::ExecutionPlan_v8::computeWorkSpaceSize(), cudnn_frontend::Engine_v8::Engine_v8(), cudnn_frontend::EngineHeuristics_v8::getEngineConfig(), cudnn_frontend::EngineHeuristics_v8::getEngineConfigCount(), and cudnn_frontend::OperationGraph_v8::getEngineCount().

## ◆ status

cudnnStatus_t cudnn_frontend::BackendDescriptor::status = CUDNN_STATUS_SUCCESS
| mutableprotected

Shared pointer of the OpaqueBackendPointer.

Error code if any being set

Definition at line 160 of file cudnn_backend_base.h.

Referenced by cudnn_frontend::MatMulDescBuilder_v8::build(), cudnn_frontend::ReductionDescBuilder_v8::build(), cudnn_frontend::VariantPackBuilder_v8::build(), cudnn_frontend::OperationGraphBuilder_v8::build(), cudnn_frontend::EngineHeuristicsBuilder_v8::build(), cudnn_frontend::EngineConfigBuilder_v8::build(), cudnn_frontend::ConvDescBuilder_v8::build(), cudnn_frontend::TensorBuilder_v8::build(), cudnn_frontend::PointWiseDescBuilder_v8::build(), cudnn_frontend::EngineBuilder_v8::build(), cudnn_frontend::ExecutionPlanBuilder_v8::build(), cudnn_frontend::OperationBuilder_v8::build(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_data(), cudnn_frontend::OperationBuilder_v8::build_conv_backward_filter(), cudnn_frontend::OperationBuilder_v8::build_conv_forward(), cudnn_frontend::OperationBuilder_v8::build_matmul_op(), cudnn_frontend::OperationBuilder_v8::build_pointwise_op(), cudnn_frontend::OperationBuilder_v8::build_reduction_op(), cudnn_frontend::Engine_v8::buildKnobs(), cudnn_frontend::ExecutionPlan_v8::buildTag(), cudnn_frontend::ExecutionPlan_v8::computeWorkSpaceSize(), cudnn_frontend::Engine_v8::Engine_v8(), cudnn_frontend::EngineConfig_v8::EngineConfig_v8(), cudnn_frontend::ExecutionPlan_v8::fetchNotes(), cudnn_frontend::EngineHeuristics_v8::getEngineConfig(), cudnn_frontend::EngineHeuristics_v8::getEngineConfigCount(), cudnn_frontend::OperationGraph_v8::getEngineCount(), and cudnn_frontend::EngineConfigBuilder_v8::setEngine().

The documentation for this class was generated from the following file:

- cudnn_backend_base.h